import { Injectable, ɵɵdefineInjectable, Component, Input, NgModule } from '@angular/core';
import { BehaviorSubject } from 'rxjs/internal/BehaviorSubject';
import { Subject, Observable } from 'rxjs';
import { __values } from 'tslib';
import { NavigationEnd, Router, ActivatedRoute, RouterModule } from '@angular/router';
import { Subscription } from 'rxjs/internal/Subscription';
import { filter } from 'rxjs/operators';
import { isNullOrUndefined } from 'util';
import { CommonModule } from '@angular/common';

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NeoCrumbService = /** @class */ (function () {
    function NeoCrumbService() {
        this.change$ = new BehaviorSubject([]);
        this.postProcess$ = new Subject();
    }
    /**
     * @param {?} data
     * @return {?}
     */
    NeoCrumbService.prototype.postProcess = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this.postProcess$.next(data);
    };
    /**
     * @param {?} data
     * @return {?}
     */
    NeoCrumbService.prototype.change = /**
     * @param {?} data
     * @return {?}
     */
    function (data) {
        this.change$.next(data);
    };
    Object.defineProperty(NeoCrumbService.prototype, "onPostProcess", {
        get: /**
         * @return {?}
         */
        function () {
            var _this = this;
            return new Observable((/**
             * @param {?} fn
             * @return {?}
             */
            function (fn) { return _this.postProcess$.subscribe(fn); }));
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(NeoCrumbService.prototype, "onChange", {
        get: /**
         * @return {?}
         */
        function () {
            var _this = this;
            return new Observable((/**
             * @param {?} fn
             * @return {?}
             */
            function (fn) { return _this.change$.subscribe(fn); }));
        },
        enumerable: true,
        configurable: true
    });
    NeoCrumbService.decorators = [
        { type: Injectable, args: [{
                    providedIn: 'root'
                },] }
    ];
    /** @nocollapse */
    NeoCrumbService.ctorParameters = function () { return []; };
    /** @nocollapse */ NeoCrumbService.ngInjectableDef = ɵɵdefineInjectable({ factory: function NeoCrumbService_Factory() { return new NeoCrumbService(); }, token: NeoCrumbService, providedIn: "root" });
    return NeoCrumbService;
}());
if (false) {
    /**
     * @type {?}
     * @private
     */
    NeoCrumbService.prototype.change$;
    /**
     * @type {?}
     * @private
     */
    NeoCrumbService.prototype.postProcess$;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NeoCrumbComponent = /** @class */ (function () {
    function NeoCrumbComponent(router, activatedRoute, neoCrumbService) {
        this.router = router;
        this.activatedRoute = activatedRoute;
        this.neoCrumbService = neoCrumbService;
        this.routeLinks = [];
        this.subscriptions = new Subscription();
    }
    /**
     * @return {?}
     */
    NeoCrumbComponent.prototype.ngOnInit = /**
     * @return {?}
     */
    function () {
        var _this = this;
        this.routeLinks = this.createBreadcrumbs(this.activatedRoute.root);
        /** @type {?} */
        var postProcessSubscription = this.neoCrumbService.onPostProcess
            .subscribe((/**
         * @param {?} value
         * @return {?}
         */
        function (value) { return _this.routeLinks = value; }));
        /** @type {?} */
        var routerEventsSubscription = this.router.events
            .pipe(filter((/**
         * @param {?} event
         * @return {?}
         */
        function (event) { return event instanceof NavigationEnd; })))
            .subscribe((/**
         * @return {?}
         */
        function () { return _this.routeLinks = _this.createBreadcrumbs(_this.activatedRoute.root); }));
        this.subscriptions.add(routerEventsSubscription);
        this.subscriptions.add(postProcessSubscription);
    };
    /**
     * @private
     * @param {?} route
     * @param {?=} url
     * @param {?=} breadcrumbs
     * @return {?}
     */
    NeoCrumbComponent.prototype.createBreadcrumbs = /**
     * @private
     * @param {?} route
     * @param {?=} url
     * @param {?=} breadcrumbs
     * @return {?}
     */
    function (route, url, breadcrumbs) {
        var e_1, _a;
        if (url === void 0) { url = ''; }
        if (breadcrumbs === void 0) { breadcrumbs = []; }
        /** @type {?} */
        var children = route.children;
        if (children.length === 0) {
            this.neoCrumbService.change(breadcrumbs);
            return breadcrumbs;
        }
        try {
            for (var children_1 = __values(children), children_1_1 = children_1.next(); !children_1_1.done; children_1_1 = children_1.next()) {
                var child = children_1_1.value;
                /** @type {?} */
                var routeURL = this.getRouteUrl(child.snapshot.url);
                /** @type {?} */
                var breadcrumb = child.snapshot.data['breadcrumb'];
                if (routeURL !== '') {
                    url += "/" + routeURL;
                }
                if (!isNullOrUndefined(breadcrumb) && !(routeURL === '' && child.children.length < 1))
                    breadcrumbs.push({ text: breadcrumb.text, link: url, iconClass: breadcrumb.iconClass, hide: breadcrumb.hide });
                return this.createBreadcrumbs(child, url, breadcrumbs);
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (children_1_1 && !children_1_1.done && (_a = children_1.return)) _a.call(children_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
    };
    /**
     * @param {?} segment
     * @return {?}
     */
    NeoCrumbComponent.prototype.getRouteUrl = /**
     * @param {?} segment
     * @return {?}
     */
    function (segment) {
        return segment.map((/**
         * @param {?} seg
         * @return {?}
         */
        function (seg) { return seg.path; })).join('/');
    };
    /**
     * @param {?} index
     * @return {?}
     */
    NeoCrumbComponent.prototype.isActive = /**
     * @param {?} index
     * @return {?}
     */
    function (index) {
        return index == this.routeLinks.length - 1;
    };
    /**
     * @return {?}
     */
    NeoCrumbComponent.prototype.ngOnDestroy = /**
     * @return {?}
     */
    function () {
        this.subscriptions.unsubscribe();
    };
    NeoCrumbComponent.decorators = [
        { type: Component, args: [{
                    selector: 'nc-neo-crumb',
                    template: "<nav aria-label=\"breadcrumb\" *ngIf=\"routeLinks && routeLinks.length && !routeLinks[routeLinks.length -1].hide\">\r\n\t<ol class=\"neo-breadcrumb\" [class.d-inline-block]=\"inlineBlock\">\r\n\t\t<ng-container *ngFor=\"let routeLink of routeLinks; let i = index\">\r\n\t\t\t<li class=\"neo-breadcrumb-item\" *ngIf=\"!isActive(i)\">\r\n\t\t\t\t<a [routerLink]=\"[routeLink.link]\">\r\n\t\t\t\t\t<i *ngIf=\"routeLink.iconClass\" [classList]=\"routeLink.iconClass\"></i>\r\n\t\t\t\t\t{{routeLink.text}}\r\n\t\t\t\t</a>\r\n\t\t\t</li>\r\n\t\t\t<li class=\"neo-breadcrumb-item active\" *ngIf=\"isActive(i)\">\r\n\t\t\t\t<i *ngIf=\"routeLink.iconClass\" [classList]=\"routeLink.iconClass\"></i>\r\n\t\t\t\t{{routeLink.text}}\r\n\t\t\t</li>\r\n\t\t</ng-container>\r\n\t</ol>\r\n</nav>\r\n"
                }] }
    ];
    /** @nocollapse */
    NeoCrumbComponent.ctorParameters = function () { return [
        { type: Router },
        { type: ActivatedRoute },
        { type: NeoCrumbService }
    ]; };
    NeoCrumbComponent.propDecorators = {
        inlineBlock: [{ type: Input }]
    };
    return NeoCrumbComponent;
}());
if (false) {
    /** @type {?} */
    NeoCrumbComponent.prototype.inlineBlock;
    /** @type {?} */
    NeoCrumbComponent.prototype.routeLinks;
    /** @type {?} */
    NeoCrumbComponent.prototype.subscriptions;
    /**
     * @type {?}
     * @private
     */
    NeoCrumbComponent.prototype.router;
    /**
     * @type {?}
     * @private
     */
    NeoCrumbComponent.prototype.activatedRoute;
    /**
     * @type {?}
     * @private
     */
    NeoCrumbComponent.prototype.neoCrumbService;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
/**
 * @record
 */
function RouteLink() { }
if (false) {
    /** @type {?} */
    RouteLink.prototype.text;
    /** @type {?} */
    RouteLink.prototype.link;
    /** @type {?|undefined} */
    RouteLink.prototype.iconClass;
    /** @type {?|undefined} */
    RouteLink.prototype.hide;
}

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */
var NeoCrumbModule = /** @class */ (function () {
    function NeoCrumbModule() {
    }
    /**
     * @return {?}
     */
    NeoCrumbModule.forRoot = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: NeoCrumbModule,
        };
    };
    /**
     * @return {?}
     */
    NeoCrumbModule.forChild = /**
     * @return {?}
     */
    function () {
        return {
            ngModule: NeoCrumbModule
        };
    };
    NeoCrumbModule.decorators = [
        { type: NgModule, args: [{
                    declarations: [NeoCrumbComponent],
                    imports: [
                        CommonModule,
                        RouterModule.forChild([]),
                    ],
                    exports: [NeoCrumbComponent]
                },] }
    ];
    return NeoCrumbModule;
}());

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

/**
 * @fileoverview added by tsickle
 * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
 */

export { NeoCrumbComponent, NeoCrumbModule, NeoCrumbService };
//# sourceMappingURL=ngx-neocrumb.js.map
